<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

    <xsl:output method="html" encoding="ISO-8859-1" />


    <xsl:template match="/">
        <html>
			<head>
				<style type="text/css">
					p {border-bottom: medium solid #81788D}
					h3 {color:#FFFFFF }
				</style>
			</head>
			<body>
				<xsl:apply-templates select="device"/>
				
			</body>
		</html>
	</xsl:template>

	<xsl:template match = "device">
		<h1>DEVICE: <xsl:value-of select="deviceName"/></h1>
		<h2>VERSION: <xsl:value-of select="version"/></h2>
		<hr/>
		<xsl:apply-templates select="padList"/>
	</xsl:template>
	
	<xsl:template match = "padList">
		<xsl:apply-templates select="pad"/>
	</xsl:template>
	
	<xsl:template match = "pad">
	<table>
	<tr>
		
		<th colspan="3" align="center">
		<h2><xsl:value-of select="name"/></h2>
		</th>
	</tr>
	<tr>
		
		<td>
		<xsl:apply-templates select="confregister" />
		<br/>
		</td>
		<td width="200"/>
		<td valign="top">
		<xsl:apply-templates select="muxmode" />
		<br/>
		<xsl:apply-templates select="bufferstrength" />
		</td>
	</tr>
	</table>

	<p/>
	</xsl:template>
	
	<xsl:template match = "confregister">
		<table border="2">
			<caption>CONFIGURATION REGISTER INFORMATION</caption>
			<tr>
				<th>Register Name</th>
				<td><xsl:value-of select="regName" /></td>
			</tr>
			<tr bgcolor="CCFFFF">
				<th>Address</th>
				<td>0x<xsl:value-of select="address"/></td>
			</tr>
			<tr>
				<th>Value</th>
				<td>0x<xsl:value-of select="currentValue"/></td>
			</tr>
			<tr bgcolor="CCFFFF">
				<th>Modification State</th>
				<td><xsl:value-of select="modState"/></td>
			</tr>	
			<tr>
				<th>Significant Half</th>
				<td><xsl:value-of select="signifHalf"/></td>
			</tr>
		</table>
		<br/>
		<br/>
		<table border="2">
			<caption>REGISTER MODEL</caption>
			<tr>
				<th>POSITION</th>
				<xsl:apply-templates select="regbit/position"/>
			</tr>
			<tr>
				<th>BITFIELD</th>
				<xsl:apply-templates select="regbit" mode="bitfield"/>
			</tr>
			<tr bgcolor="C0C0C0">
				<th>RESET VALUE</th>
				<xsl:apply-templates select="regbit" mode="reseting"/>
			</tr>
		</table>
	</xsl:template>
	
	<xsl:template match="regbit/position">
		<td><xsl:value-of select="."/></td>
	</xsl:template>
	<xsl:template match="regbit" mode="bitfield">                 
		<!-- Here I want to assing an element value to attribute -->
		<xsl:if test="bitfield = 'RESERVED'">
		<td bgcolor="C0C0C0" STYLE="writing-mode: tb-rl">
			<!-- add attribute + value -->
			<xsl:attribute name="colspan">
				<xsl:value-of select="width" />
			</xsl:attribute>	
			
			<xsl:value-of select="bitfield" />
		</td>
		</xsl:if>
		
		<xsl:if test="bitfield != 'RESERVED'">
		<td STYLE="writing-mode: tb-rl">
			<!-- add attribute + value -->
			<xsl:attribute name="colspan">
				<xsl:value-of select="width" />
			</xsl:attribute>	
			
			<xsl:value-of select="bitfield" />
		</td>
		</xsl:if>
	</xsl:template>
	<xsl:template match="regbit" mode="reseting">
		<td >
			<xsl:attribute name="colspan">
				<xsl:value-of select="width" />
			</xsl:attribute>
			<xsl:value-of select="reseting"/>
		</td>
	</xsl:template>
	<xsl:template match="muxmode">
		<table border="2">
			<xsl:attribute name="bgcolor">
				<xsl:value-of select="color" />
			</xsl:attribute>
			<tr>
				<td colspan="2" align="center"><h3>MUXMODE</h3></td>
			</tr>
			<tr>
			<th><h3>MODE NUMBER</h3></th>
			<td><h3><xsl:value-of select="mode" /></h3></td>
			</tr>
			<tr>
			<th><h3>SIGNAL</h3></th>
			<td><h3><xsl:value-of select="signal" /></h3></td>
			</tr>
		</table>
	</xsl:template>
	<xsl:template match="bufferstrength">
		<table border="2">
			<tr>
				<td colspan="2" align="center">BUFFER STRENGHT</td>
			</tr>
			<tr>
			<th>VALUE</th>
			<td><xsl:value-of select="value" /></td>
			</tr>
			<tr>
			<th>DESCRIPTION</th>
			<td><xsl:value-of select="description" /></td>
			</tr>
		</table>
	</xsl:template>
</xsl:stylesheet>  
